Package org.eclipse.emf.cdo.compare

## Class CDOComparisonScope.Minimal

- java.lang.Object
- - org.eclipse.emf.common.notify.impl.AdapterImpl
  - - org.eclipse.emf.compare.scope.AbstractComparisonScope
    - - org.eclipse.emf.cdo.compare.CDOComparisonScope
      - - org.eclipse.emf.cdo.compare.CDOComparisonScope.Minimal

- All Implemented Interfaces:
    `com.google.common.base.Predicate<org.eclipse.emf.ecore.EObject>`, `java.util.function.Predicate<org.eclipse.emf.ecore.EObject>`, `org.eclipse.emf.common.notify.Adapter`, `org.eclipse.emf.common.notify.Adapter.Internal`, `org.eclipse.emf.compare.scope.IComparisonScope`, `org.eclipse.emf.compare.scope.IComparisonScope2`, `org.eclipse.emf.compare.utils.IDiagnosable`
  Enclosing class:
    CDOComparisonScope

      public static class CDOComparisonScope.Minimal
      extends CDOComparisonScope
      implements com.google.common.base.Predicate<org.eclipse.emf.ecore.EObject>

  Takes a `view`/`transaction` and returns `matches` only for the changed elements of the entire content tree of its `root resource`. The advantage of this scope is that CDO-specific mechanisms are used to efficiently (remotely) determine the set of changed objects. Only those and their container objects are considered as matches, making this scope scale seamlessly with the overall size of a repository. The following method returns comparisons that are based on this scope algorithm:
  - `CDOCompareUtil.compare(CDOView, CDOView, CDOView[])`
  Author:
    Eike Stepper

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.eclipse.emf.cdo.compare.CDOComparisonScope

      `CDOComparisonScope.AllContents, CDOComparisonScope.Minimal`

    - ### Nested classes/interfaces inherited from interface org.eclipse.emf.common.notify.Adapter

      `org.eclipse.emf.common.notify.Adapter.Internal`

  - ### Field Summary

    - ### Fields inherited from class org.eclipse.emf.compare.scope.AbstractComparisonScope

      `allInvolvedResourceURIs, diagnostic, left, nsURIs, origin, resourceURIs, right`

    - ### Fields inherited from class org.eclipse.emf.common.notify.impl.AdapterImpl

      `target`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Minimal​(CDOView leftView, CDOView rightView, CDOView originView, java.util.Set<CDOID> ids)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `apply​(org.eclipse.emf.ecore.EObject input)` |
    `protected void` | `collectRequiredParentID​(CDOView view, CDOID id, java.util.Set<CDOID> requiredParentIDs)` |
    `static org.eclipse.emf.compare.scope.IComparisonScope` | `create​(CDOTransaction transaction)` |
    `static org.eclipse.emf.compare.scope.IComparisonScope` | `create​(CDOTransaction transaction, CDOViewOpener viewOpener)` |
    `static org.eclipse.emf.compare.scope.IComparisonScope` | `create​(CDOView leftView, CDOView rightView, CDOView[] originView)` |
    `static org.eclipse.emf.compare.scope.IComparisonScope` | `create​(CDOView leftView, CDOView rightView, CDOView[] originView, java.util.Set<CDOID> ids)` |
    `static org.eclipse.emf.compare.scope.IComparisonScope` | `create​(CDOView leftView, CDOView rightView, CDOView[] originView, java.util.Set<CDOID> ids, CDOViewOpener viewOpener)` |
    `static org.eclipse.emf.compare.scope.IComparisonScope` | `create​(CDOView leftView, CDOView rightView, CDOView[] originView, CDOViewOpener viewOpener)` |
    `java.util.Iterator<? extends org.eclipse.emf.ecore.EObject>` | `getChildren​(org.eclipse.emf.ecore.EObject eObject)` |

    - ### Methods inherited from class org.eclipse.emf.cdo.compare.CDOComparisonScope

      `getCoveredEObjects, getCoveredResources, isResolveProxies, setResolveProxies`

    - ### Methods inherited from class org.eclipse.emf.compare.scope.AbstractComparisonScope

      `getAllInvolvedResourceURIs, getDiagnostic, getLeft, getNsURIs, getOrigin, getResourceURIs, getRight, isAdapterForType, setDiagnostic`

    - ### Methods inherited from class org.eclipse.emf.common.notify.impl.AdapterImpl

      `getTarget, notifyChanged, setTarget, unsetTarget`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.base.Predicate

      `equals, test`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Constructor Detail

    - #### Minimal

          public Minimal​(CDOView leftView,
                         CDOView rightView,
                         CDOView originView,
                         java.util.Set<CDOID> ids)

  - ### Method Detail

    - #### getChildren

          public java.util.Iterator<? extends org.eclipse.emf.ecore.EObject> getChildren​(org.eclipse.emf.ecore.EObject eObject)

      Specified by:
        `getChildren` in interface `org.eclipse.emf.compare.scope.IComparisonScope`

    - #### apply

          public boolean apply​(org.eclipse.emf.ecore.EObject input)

      Specified by:
        `apply` in interface `com.google.common.base.Predicate<org.eclipse.emf.ecore.EObject>`

    - #### collectRequiredParentID

          protected void collectRequiredParentID​(CDOView view,
                                                 CDOID id,
                                                 java.util.Set<CDOID> requiredParentIDs)

    - #### create

          public static org.eclipse.emf.compare.scope.IComparisonScope create​(CDOView leftView,
                                                                              CDOView rightView,
                                                                              CDOView[] originView)

    - #### create

          public static org.eclipse.emf.compare.scope.IComparisonScope create​(CDOView leftView,
                                                                              CDOView rightView,
                                                                              CDOView[] originView,
                                                                              CDOViewOpener viewOpener)

      Since:
        4.3

    - #### create

          public static org.eclipse.emf.compare.scope.IComparisonScope create​(CDOView leftView,
                                                                              CDOView rightView,
                                                                              CDOView[] originView,
                                                                              java.util.Set<CDOID> ids)

    - #### create

          public static org.eclipse.emf.compare.scope.IComparisonScope create​(CDOView leftView,
                                                                              CDOView rightView,
                                                                              CDOView[] originView,
                                                                              java.util.Set<CDOID> ids,
                                                                              CDOViewOpener viewOpener)

      Since:
        4.3

    - #### create

          public static org.eclipse.emf.compare.scope.IComparisonScope create​(CDOTransaction transaction)

    - #### create

          public static org.eclipse.emf.compare.scope.IComparisonScope create​(CDOTransaction transaction,
                                                                              CDOViewOpener viewOpener)

      Since:
        4.3